"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.updateDom = exports.removeHighlightFromDom = exports.isHighlightable = exports.addHighlight = void 0;
var addHighlight = function (range, element) {
    var _a;
    if (!(0, exports.isHighlightable)(range)) {
        return;
    }
    var exists = document.getElementById(element.id);
    if (exists) {
        exists.className = element.className;
        return;
    }
    element.appendChild(range.extractContents());
    range.insertNode(element);
    (_a = window.getSelection()) === null || _a === void 0 ? void 0 : _a.removeAllRanges();
};
exports.addHighlight = addHighlight;
var isHighlightable = function (range) {
    var contents = range.cloneContents();
    var hasp = [];
    contents.childNodes.forEach(function (item) {
        if (item.nodeName === 'P') {
            hasp.push(true);
        }
        else {
            hasp.push(false);
        }
    });
    return !hasp.includes(true);
};
exports.isHighlightable = isHighlightable;
var constants_1 = require("../constants/constants");
var removeHighlightFromDom = function (selection) {
    var element = document.getElementById(selection.id);
    var popover = document.getElementById("pop-".concat(selection.id));
    if (!element)
        return;
    element.className = '';
    element.setAttribute('style', '');
    // const newSpan = document.createElement('span')
    // while (element.firstChild) {
    //   newSpan.appendChild(element.firstChild)
    // }
    // element.parentElement?.replaceChildren(element, newSpan)
    if (popover) {
        element.removeChild(popover);
    }
};
exports.removeHighlightFromDom = removeHighlightFromDom;
var updateDom = function (selection) {
    var element = document.getElementById(selection.id);
    if (!element)
        return;
    element.className = selection.className || constants_1.defaultSelectionWrapperClassName;
    element.setAttribute('style', '');
};
exports.updateDom = updateDom;
