import { __awaiter, __generator } from "tslib";
import { jsx as _jsx } from "react/jsx-runtime";
import { useRef } from 'react';
import ReactDOM from 'react-dom/client';
import HTMLReactParser from 'html-react-parser/lib/index';
import { deserializeRange, serializeRange } from '../../libs/serialize';
import { useCallback, useEffect, useMemo } from 'react';
import { generateId } from '../../libs/uid';
import { getPopoverElement, getSpanElement } from '../../libs/wrapperElements';
import DefaultPopover from '../DeafultPopover';
import { useSelections } from '../../hooks/UseSelection';
import { defaultMinSelectionLength, defaultSelectionWrapperClassName } from '../../constants/constants';
import { addHighlight, isHighlightable } from '../../libs/dom';
export var Highlighter = function (_a) {
    var htmlString = _a.htmlString, onClickHighlight = _a.onClickHighlight, disablePopover = _a.disablePopover, maxSelectionLength = _a.maxSelectionLength, minSelectionLength = _a.minSelectionLength, className = _a.className, PopoverChildren = _a.PopoverChildren, PopoverClassName = _a.PopoverClassName, selectionWrapperClassName = _a.selectionWrapperClassName, onClick = _a.onClick;
    var _b = useSelections(), selections = _b.selections, addSelection = _b.addSelection, removeSelection = _b.removeSelection, updateSelection = _b.updateSelection;
    var popoverRoots = useRef({});
    var content = useMemo(function () { return HTMLReactParser(htmlString); }, [htmlString]);
    var getWrapper = useCallback(function (selection) {
        var span = getSpanElement({ className: selection.className || defaultSelectionWrapperClassName });
        if (!disablePopover) {
            var popover_1 = getPopoverElement({ className: PopoverClassName });
            if (!PopoverClassName) {
                span.addEventListener('mouseover', function () {
                    popover_1.style.visibility = 'visible';
                    popover_1.style.opacity = '1';
                });
                span.addEventListener('mouseout', function () {
                    popover_1.style.visibility = 'hidden';
                    popover_1.style.opacity = '0';
                });
            }
            popover_1.id = "pop-".concat(selection.id);
            span.appendChild(popover_1);
            var root = ReactDOM.createRoot(popover_1);
            popoverRoots.current[selection.id] = root;
        }
        if (onClickHighlight) {
            span.onclick = function (e) { return onClickHighlight(selection, e); };
        }
        span.id = selection.id;
        return span;
    }, [PopoverClassName, disablePopover, onClickHighlight]);
    var handleMouseUp = function () {
        var selection = window.getSelection();
        if (!selection)
            return;
        if (!minSelectionLength) {
            minSelectionLength = defaultMinSelectionLength;
        }
        if (minSelectionLength && selection.toString().length < minSelectionLength)
            return;
        if (maxSelectionLength && selection.toString().length > maxSelectionLength)
            return;
        var range = selection.getRangeAt(0);
        if (!isHighlightable(range))
            return;
        var newSelection = {
            meta: serializeRange(range),
            text: range.toString(),
            id: "selection-".concat(generateId()),
            className: selectionWrapperClassName || defaultSelectionWrapperClassName,
        };
        addSelection(newSelection);
    };
    useEffect(function () {
        var currentRefs = popoverRoots.current;
        if (selections && selections.length) {
            selections.forEach(function (item) { return __awaiter(void 0, void 0, void 0, function () {
                var range;
                var _a, _b;
                return __generator(this, function (_c) {
                    switch (_c.label) {
                        case 0: return [4 /*yield*/, deserializeRange(item.meta)];
                        case 1:
                            range = _c.sent();
                            if (range) {
                                addHighlight(range, getWrapper(item));
                            }
                            if (PopoverChildren) {
                                (_a = popoverRoots.current[item.id]) === null || _a === void 0 ? void 0 : _a.render(_jsx(PopoverChildren, { selection: item, removeSelection: removeSelection, updateSelection: updateSelection }));
                            }
                            else {
                                (_b = popoverRoots.current[item.id]) === null || _b === void 0 ? void 0 : _b.render(_jsx(DefaultPopover, { removeSelection: removeSelection, selection: item, updateSelection: updateSelection }));
                            }
                            return [2 /*return*/];
                    }
                });
            }); });
        }
        return function () {
            Object.keys(currentRefs).forEach(function (item) { return function () { var _a; return (_a = currentRefs[item]) === null || _a === void 0 ? void 0 : _a.unmount(); }; });
        };
    }, [selections, getWrapper, PopoverChildren, removeSelection, updateSelection]);
    return (_jsx("div", { onClick: onClick, onMouseUp: handleMouseUp, className: className, children: content }));
};
