export var addHighlight = function (range, element) {
    var _a;
    if (!isHighlightable(range)) {
        return;
    }
    var exists = document.getElementById(element.id);
    if (exists) {
        exists.className = element.className;
        return;
    }
    element.appendChild(range.extractContents());
    range.insertNode(element);
    (_a = window.getSelection()) === null || _a === void 0 ? void 0 : _a.removeAllRanges();
};
export var isHighlightable = function (range) {
    var contents = range.cloneContents();
    var hasp = [];
    contents.childNodes.forEach(function (item) {
        if (item.nodeName === 'P') {
            hasp.push(true);
        }
        else {
            hasp.push(false);
        }
    });
    return !hasp.includes(true);
};
import { defaultSelectionWrapperClassName } from '../constants/constants';
export var removeHighlightFromDom = function (selection) {
    var element = document.getElementById(selection.id);
    var popover = document.getElementById("pop-".concat(selection.id));
    if (!element)
        return;
    element.className = '';
    element.setAttribute('style', '');
    // const newSpan = document.createElement('span')
    // while (element.firstChild) {
    //   newSpan.appendChild(element.firstChild)
    // }
    // element.parentElement?.replaceChildren(element, newSpan)
    if (popover) {
        element.removeChild(popover);
    }
};
export var updateDom = function (selection) {
    var element = document.getElementById(selection.id);
    if (!element)
        return;
    element.className = selection.className || defaultSelectionWrapperClassName;
    element.setAttribute('style', '');
};
